"""
 Beispiel: Autorennen, Variante 1
 Hier wird das Sprite wird als Attribut des Autos eingebunden.

 Definition einer Klasse Auto unter Benutzung der neuen Klasse Sprite.
 Ableitung zweier Instanzen.
 Nutzung einer Schleife mit Tastaturabfrage zur Steuerung der Autos
"""
from sum import *

# Definition eines Autos

class Auto:
  def __init__(self):
    self.bild=Sprite("auto.bmp",bildschirm)
    self.bild.bewegeBis(100,100)
   
  def gibFrei(self):
    pass

  def bewegeBis(self,x,y):
    self.bild.bewegeBis(x,y)

  def bewegeUm(self,laenge):
    self.bild.bewegeBis(self.bild.hPosition()+laenge,self.bild.vPosition())
  
  def istAngekommen(self):
    return self.bild.hPosition()>400

    
# Erzeuge Bildschirm und Maus
bildschirm=Bildschirm()
maus=Maus()
tastatur=Tastatur()
stift=Stift()
stift.bewegeBis(20,20)
stift.schreibe("Autorennen! Steuerung Auto1 mit <y>, Auto2 mit <->")

# Erzeuge 2 Autos
auto1=Auto()
auto1.bewegeBis(100,100)

auto2=Auto()
auto2.bewegeBis(100,200)

# Autos bewegen bis Sieger gefunden
sieger=0

while sieger==0:
  auto1.bewegeUm(1)
  auto2.bewegeUm(1)

  if tastatur.wurdeGedrueckt():
    z=tastatur.zeichen()

    if z=="y":
      auto1.bewegeUm(2)
      
    if z=="-":
      auto2.bewegeUm(2)

  if auto1.istAngekommen():
    stift.schreibe("Auto1 ist Sieger!")
    sieger=1

  if auto2.istAngekommen():
    stift.schreibe("Auto2 ist Sieger!")
    sieger=2

# Und Ende.
tastatur.gibFrei()
maus.gibFrei()
bildschirm.gibFrei()
