"""
 Beispiel: Ein Aquarium mit Fischen
"""

from sum import *
       
class Fisch(Sprite):
    # Ein Fisch
    def update(self):
        # Bewege den Fisch in RIchtung move
        # self.move=(self.move[0]*0.995,self.move[1]*0.995)
        self.setpos((self.pos[0]+self.move[0],self.pos[1]+self.move[1]))
        # Wenn Fisch am Beckenrand angekommen, Richtung ndern.
        if self.pos[1]>480:
          self.move=(self.move[0],-self.move[1])
          self.setpos((self.pos[0],440))
        if self.pos[1]<1:
          self.move=(self.move[0],-self.move[1])
          self.setpos((self.pos[0],1))
        if self.pos[0]>640:
          self.move=(-2,self.move[1])
        if self.pos[0]<1:
          self.move=(2,self.move[1])

    def speedup(self,other):
        # Drehe den Fisch weg von anderem Fisch
        if self.hPosition()<other.hPosition():
          self.move=(random.randrange(-2,-1),random.randrange(-2,2) )
        else:
          self.move=(random.randrange(1,2),random.randrange(-2,2) )
        if self.move[1]<0:
          self.dreheBis(random.randrange(0,20))
        if self.move[1]>0:
          self.dreheBis(random.randrange(-20,0))

def main():
    bild=Bildschirm("background.gif")
    hand = Sprite("hand.bmp",bild)
    maus=Maus(bild)
    tast=Tastatur()
    Fisch1 = Fisch("fisch.bmp",bild) 
    Fisch2 = Fisch("fisch2.bmp",bild)
    Fisch3 = Fisch("fisch3.bmp",bild)
    Fisch4 = Fisch("fisch4.bmp",bild)
    fischliste=[Fisch1,Fisch2,Fisch3,Fisch4]
    for i in fischliste:
      i.bewegeBis(random.randrange(400),random.randrange(400))

    while not tast.wurdeGedrueckt():
      pos=maus.position()
      hand.setpos(pos)
      for testfisch in fischliste:
        testfisch.update()
        if maus.istGedrueckt ():
          if testfisch.kollidiert(hand):
            testfisch.speedup(hand)
            

# call the "main" function if running this script
if __name__ == '__main__': main()
