# Kommunikatonstest Client-Server
# Zum Testen erst einmalig den Server, dann den Client starten.

from socket import *
import time

global c

def list2str(l):
  r=""
  for i in l:
    if r != "": r=r+"|"
    if type(i)==type(" "):
      r=r+'"'+i+'"'
    else:
      r=r+str(i)
  return r


def send(t,*args):
  # Client sendet t
  global c
  if args==():
    c.send(t+";")
  else:
    c.send(t+" "+str(args)[:-1][1:]+";")

def request(t):
  # Client sendet t und wartet auf Anwort
  global c
  c.send(t+";")
  r = c.recv(1024)
  return r

def client_init():
  # CLient aktiviert Socket
  global c
  print "Erzeuge Socket...",
  c=socket(AF_INET,SOCK_STREAM)
  c.setsockopt(SOL_SOCKET,SO_KEEPALIVE,1)
  print "OK"
  print "Connect...",
  c.connect(("localhost",9050))
  print "OK"
  time.sleep(1)

def client_test():
  # Client testet Kommunikation
  print "--- CLIENT --"
  client_init()
  while 1:
    print "Sende Daten...",
    send(list2str(["plot",20,20]))
    send(list2str(["line",4,6,44,66]))
    print "OK"
    
    print "Abfrage Daten...",
    mp=request(list2str(["mouse"]))
    print "Antwort OK",mp

    x=raw_input("Enter=Nochmal, e=Ende, f=Fehler erzeugen")
    if x=="e": break
    if x=="f": raise "Dummer Fehler"
  #endwhile

  send("exit")
  time.sleep(1)
  c.close()

def server_test():
  # Server erzeugt socket und gibt reagiert auf empfangene Daten
  print "--- SERVER ---"
  print "Starte Socket..."
  s=socket(AF_INET,SOCK_STREAM)
  s.setsockopt(SOL_SOCKET,SO_KEEPALIVE,1)
  s.bind(("",9050))
  
  print "OK"
  print "Warte auf Verbindung...",
  s.listen(5)
  (conn,addr)=s.accept()
  print "OK"
  conn.setblocking(0)

  ein=""
  raus=0
  while not raus:
    try:
      rec = conn.recv(1024)
      if len(rec)<1:
        print "Fehler!!"
        raus=1
      ein = ein + rec
    except error, nummer:
      if nummer[0]<>10035:
        print "Abbruch, Fehler#",nummer
        raus=1
      
      while ein.count(";")>0:
        pos = ein.index(";")
        befehl = ein[:pos]
        ein = ein [pos+1:]

        print "Empfangen",befehl
        if befehl=="exit": raus=1
        if befehl=="frage":
           print "sende Antwort"
           conn.send("Antwort")

    time.sleep(1)
    print "*",

def start():
  #e=raw_input("Kommunikationstest. s=Server, c=Client ?")
  #if e=="s": server_test()
  client_test()
  e=raw_input("Ende. (Taste)") 

start()
