"""
 Beispiel: Definition einer Klasse Ball
"""

from sum import *

# Definition eines Balls
class Ball:
  def __init__(self):
    self.hPosition=100
    self.vPosition=100
    self.xRichtung=4
    self.yRichtung=2
    self.stift=Stift(bildschirm)
  
  def gibFrei(self):
    # Freigeben macht nichts
    self.stift.gibFrei()
    
  def zeichne(self):
    # Einen Ball an der aktuellen x/y-Position zeichnen
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition,self.vPosition)
    self.stift.runter()
    self.stift.zeichneKreis(10)
    
  def bewege(self):
    # mich selbst "wegradieren"
    self.stift.radiere()
    self.zeichne()

    # mich bewegen
    self.hPosition=self.hPosition+self.xRichtung
    self.vPosition=self.vPosition+self.yRichtung
    
    # Wenn der Ball den Rand erreicht, die Richtung ndern.
    if self.hPosition>600:
      self.xRichtung=-4
    if self.hPosition<20:
      self.xRichtung=4
    if self.vPosition<20:
      self.yRichtung=2
    if self.vPosition>400:
      self.yRichtung=-2

    # mich zeichnen
    self.stift.normal()
    self.zeichne()


# Erzeuge Bildschirm und Stift
bildschirm=Bildschirm()
maus=Maus(bildschirm)
tastatur=Tastatur(bildschirm)

# Erzeuge ein Objekt "Ball"
ball=Ball()
ball.zeichne()

# Ball bewegen bis Mausklick
while not maus.doppelKlick():
  ball.bewege()
     
# Und Ende.
tastatur.gibFrei()
maus.gibFrei()
bildschirm.gibFrei()
