"""
 Aufgabe 3.4.1: Ampel
"""

from sum import *
from time import *

# Erzeuge Bildschirm und Stift

class Lampe:
  def __init__(self,kenntstift):
    self.stift=kenntstift
    self.posx=self.stift.hPosition()
    self.posy=self.stift.vPosition()
    self.istan=0
    
  def zeigedich(self):
    self.stift.hoch()
    self.stift.bewegeBis(self.posx,self.posy)
    self.stift.runter()
    if self.istan: self.stift.setzeFuellMuster(1)
    else: self.stift.setzeFuellMuster(0)
    self.stift.zeichneKreis(30)

  def aus(self):
    self.stift.radiere()
    self.zeigedich()
    self.stift.normal()
    
    self.istan=0
    self.zeigedich()

  def ein(self):
    self.istan=1
    self.zeigedich()
  
  def isteingeschaltet(self):
    return self.istan
    
class FarbLampe(Lampe):
  def __init__(self,kenntstift):
    self.stift=kenntstift
    self.posx=self.stift.hPosition()
    self.posy=self.stift.vPosition()
    self.istan=0
    self.farbe=gelb
    
  def zeigedich(self):
    self.stift.hoch()
    self.stift.bewegeBis(self.posx,self.posy)
    self.stift.runter()
    self.stift.setzeFarbe(self.farbe)
    if self.istan: self.stift.setzeFuellMuster(1)
    else: self.stift.setzeFuellMuster(0)
    self.stift.zeichneKreis(30)  

  def setzefarbe(self,neuefarbe):
    self.farbe=neuefarbe

class Ampel:
  def __init__(self,kenntstift):
    self.stift=kenntstift
    self.stift.hoch()
    self.stift.bewegeBis(150,50)
    self.stift.runter()
    self.stift.setzeLinienbreite(10)
    self.stift.zeichneRechteck(100,300)
    self.stift.setzeLinienbreite(1)
    
    
    self.stift.hoch()

    self.stift.bewegeBis(200,100)
    self.rot=FarbLampe(self.stift)
    self.rot.setzefarbe(rot)
    
    self.stift.bewegeBis(200,200)
    self.gelb=FarbLampe(self.stift)
    self.gelb.setzefarbe(gelb)

    self.stift.bewegeBis(200,300)
    self.gruen=FarbLampe(self.stift)
    self.gruen.setzefarbe(gruen)

    self.zeigedich()
    self.rot.ein()
  
  def zeigedich(self):
    self.rot.zeigedich()
    self.gelb.zeigedich()
    self.gruen.zeigedich()

  def schalteweiter(self):
    if self.rot.isteingeschaltet():
      self.rot.aus()
      self.gruen.ein()
    elif self.gruen.isteingeschaltet():
      self.gruen.aus()
      self.gelb.ein()
    elif self.gelb.isteingeschaltet():
      self.gelb.aus()
      self.rot.ein()
    sleep(1)
   
bildschirm=Bildschirm()
stift=Buntstift()
ampel=Ampel(stift)
for i in range(6):
  ampel.schalteweiter()
bildschirm.gibFrei()